---
title: OscillatorNode
slug: Web/API/OscillatorNode
tags:
  - API
  - Constructor
  - Interface
  - Media
  - OscillatorNode
  - Reference
  - Web Audio API
---
<p>{{APIRef("Web Audio API")}}</p>

<p>The <strong><code>OscillatorNode</code></strong> interface represents a periodic waveform, such as a sine wave. It is an {{domxref("AudioScheduledSourceNode")}} audio-processing module that causes a specified frequency of a given wave to be created—in effect, a constant tone.</p>

<p>An <code>OscillatorNode</code> is created using the {{domxref("BaseAudioContext.createOscillator()")}} method. It always has exactly one output and no inputs. Its basic property defaults (see {{domxref("AudioNode")}} for definitions) are:</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Number of inputs</th>
   <td><code>0</code></td>
  </tr>
  <tr>
   <th scope="row">Number of outputs</th>
   <td><code>1</code></td>
  </tr>
  <tr>
   <th scope="row">Channel count mode</th>
   <td><code>max</code></td>
  </tr>
  <tr>
   <th scope="row">Channel count</th>
   <td><code>2</code> (not used in the default count mode)</td>
  </tr>
  <tr>
   <th scope="row">Channel interpretation</th>
   <td><code>speakers</code></td>
  </tr>
 </tbody>
</table>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{domxref("OscillatorNode.OscillatorNode", "OscillatorNode()")}}</dt>
 <dd>Creates a new instance of an <code>OscillatorNode</code> object, optionally providing an object specifying default values for the node's {{anch("properties")}}.  If the default values are acceptable, you can call the {{domxref("BaseAudioContext.createOscillator()")}} factory method.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<p><em>Inherits properties from its parent, {{domxref("AudioScheduledSourceNode")}}, and adds the following properties:</em></p>

<dl>
 <dt>{{domxref("OscillatorNode.frequency")}}</dt>
 <dd>An <a href="/en-US/docs/Web/API/AudioParam#a-rate">a-rate</a> {{domxref("AudioParam")}} representing the frequency of oscillation in hertz (though the <code style="font-size: 14px;">AudioParam</code> returned is read-only, the value it represents is not). The default value is 440 Hz (a standard middle-A note).</dd>
</dl>

<dl>
 <dt>{{domxref("OscillatorNode.detune")}}</dt>
 <dd>An <a href="/en-US/docs/Web/API/AudioParam#a-rate">a-rate</a> {{domxref("AudioParam")}} representing detuning of oscillation in cents (though the <code style="font-size: 14px;">AudioParam</code> returned is read-only, the value it represents is not). The default value is 0.</dd>
</dl>

<dl>
 <dt>{{domxref("OscillatorNode.type")}}</dt>
 <dd>A string which specifies the shape of waveform to play; this can be one of a number of standard values, or <code>custom</code> to use a {{domxref("PeriodicWave")}} to describe a custom waveform. Different waves will produce different tones. Standard values are <code>"sine"</code>, <code>"square"</code>, <code>"sawtooth"</code>, <code>"triangle"</code> and <code>"custom"</code>. The default is <code>"sine"</code>.</dd>
</dl>

<h3 id="Event_handlers">Event handlers</h3>

<dl>
 <dt>{{domxref("OscillatorNode.onended")}}</dt>
 <dd>Sets the event handler for the {{event("ended")}} event, which fires when the tone has stopped playing.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p><em>Inherits methods from its parent, {{domxref("AudioScheduledSourceNode")}}, and adds the following:</em></p>

<dl>
 <dt>{{domxref("OscillatorNode.setPeriodicWave()")}}</dt>
 <dd>Sets a {{domxref("PeriodicWave")}} which describes a periodic waveform to be used instead of one of the standard waveforms; calling this sets the <code>type</code> to <code>custom</code>. This replaces the now-obsolete {{domxref("OscillatorNode.setWaveTable()")}} method.</dd>
 <dt>{{domxref("OscillatorNode.start()")}}</dt>
 <dd>Specifies the exact time to start playing the tone.</dd>
 <dt>{{domxref("OscillatorNode.stop()")}}</dt>
 <dd>Specifies the time to stop playing the tone.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>The following example shows basic usage of an {{domxref("AudioContext")}} to create an oscillator node and to start playing a tone on it. For an applied example, check out our <a href="https://mdn.github.io/violent-theremin/">Violent Theremin demo</a> (<a href="https://github.com/mdn/violent-theremin/blob/gh-pages/scripts/app.js">see app.js</a> for relevant code).</p>

<pre class="brush: js">// create web audio api context
var audioCtx = new (window.AudioContext || window.webkitAudioContext)();

// create Oscillator node
var oscillator = audioCtx.createOscillator();

oscillator.type = 'square';
oscillator.frequency.setValueAtTime(440, audioCtx.currentTime); // value in hertz
oscillator.connect(audioCtx.destination);
oscillator.start();</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web Audio API', '#oscillatornode', 'OscillatorNode')}}</td>
   <td>{{Spec2('Web Audio API')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.OscillatorNode")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web_Audio_API/Using_Web_Audio_API">Using the Web Audio API</a></li>
</ul>
